Subject: Re: netlink locking warnings in 2.6.21-rc7-mm1

From: Patrick McHardy <[email-masked]>
Date: Wed, 25 Apr 2007 15:14:40 +0200

David Miller wrote:
> I think I see what might be the problem, nlk->cb_mutex is set
> to "rtnl_mutex" and this is used for other purposes in various
> code paths here, maybe there is a double mutex_unlock() or
> similar due to that?

Nothing in the callbacks should be touching the rtnl, that would
have been broken before since we already used to hold it during
the first invocation of the dump callback, the only difference
is that we now hold it during the entire dump operation. The
cb_mutex is only set on socket creation, so there's also nothing
that should be rewriting it.

I can't see whats wrong here.